/* Target definitions for M88000 boxes running Mach 3.0.
   Copyright (C) 1992, 1993 Free Software Foundation, Inc.

This file is part of GDB.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
 * HISTORY
 * $Log:	tm-m88kmach3.h,v $
 * Revision 2.1.1.1  93/04/16  15:52:10  pds
 * 	Created.
 * 
 */

/*
 * Include common definitions for Mach 3.0 systems.
 */
#include "os-mach3.h"

/*
 * Target specific definitions.
 */
#include <mach/m88k/thread_status.h>
#include <m88k/vmparam.h>

#define	KERNEL_U_ADDR	0	/* Not needed. */

/*
 * Define offsets to access C-thread stack when it does not have a
 * kernel thread.  From mk/user/threads/m88k/csw.s.
 */
#define	MACHINE_CPROC_SP_OFFSET		64
#define	MACHINE_CPROC_PC_OFFSET		4
#define	MACHINE_CPROC_FP_OFFSET		0

/*
 * Thread flavors used in re-setting the T bit.
 */
#define TRACE_FLAVOR		LUNA88K_THREAD_STATE
#define TRACE_FLAVOR_SIZE	LUNA88K_THREAD_STATE_COUNT
#define	TRACE_SET(state) \
	error ("TRACE_SET not implemented, unable to step.")

/*
 * On Mach 3.0 this is the number of exec() system calls before
 * the task contains the debugged program. It is always 2 when
 * using the shell to start up the program.
 */
#undef  START_INFERIOR_TRAPS_EXPECTED
#define START_INFERIOR_TRAPS_EXPECTED 2

/* Address of end of stack space for MACH, see <vmparam.h>
 */
#undef  STACK_END_ADDR
#define STACK_END_ADDR	USRSTACK

/**********************************************************************/

/* get "generic" m88k include file */
#include "tm-m88k.h"

#undef  NUM_REGS
#define NUM_REGS (/*general*/32 + /*psr*/1 + /*fp*/2 + /*ip*/3)

#undef  REGISTER_NAMES
#define REGISTER_NAMES {\
	"r0",\
	"r1",\
	"r2",\
	"r3",\
	"r4",\
	"r5",\
	"r6",\
	"r7",\
	"r8",\
	"r9",\
	"r10",\
	"r11",\
	"r12",\
	"r13",\
	"r14",\
	"r15",\
	"r16",\
	"r17",\
	"r18",\
	"r19",\
	"r20",\
	"r21",\
	"r22",\
	"r23",\
	"r24",\
	"r25",\
	"r26",\
	"r27",\
	"r28",\
	"r29",\
	"r30",\
	"r31",\
	"psr",\
	"fpsr",\
	"fpcr",\
	"sxip",\
	"snip",\
	"sfip",\
    }

/* check into the following if it becomes an issue.... */
#undef BELIEVE_PCC_PROMOTION

#if	0
/* see what the Luna does here.... */
#undef SHIFT_INST_REGS
#endif	/* 0 */

/*
 * Figure out where the longjmp will land.  We expect that we have just
 * entered longjmp and that the arguments are still in the argument registers.
 * r2 (RV_REGNUM) points at the jmp_buf structure from which we extract
 * the PC where we will land.  The PC is copied into ADDR and the routine
 * returns TRUE on success.
 */

#define	GET_LONGJMP_TARGET(ADDR)	mach3_get_longjmp_target(ADDR)

/*
 * This is the layout of the top of the emulator stack used by UX.
 * See emulator/emul_stack.h and emulator/m88k/emul_vector.s for details.
 */
struct emul_stack_top {
    CORE_ADDR			user_sp;	/* Actually a sigcontext ptr */
    CORE_ADDR			pad1;
    CORE_ADDR			pad2;
    CORE_ADDR			pad3;
    struct emul_stack_top *	link;
    mach_port_t			reply_port;
};

#ifndef	EMULATOR_STACK_SIZE
#define	EMULATOR_STACK_SIZE	(4096*4)
#endif
